﻿
Функция СозданиеКонтрагентов(МассивКонтрагентов)  Экспорт 
	//ES Ситало А И 27.10.2020 12:27:27{
	
	СтруктураОтвета = Новый Структура;
	Ошибка = Ложь;
	ТекстОшибки = "";
	НачатьТранзакцию();

	Для Каждого мКонтрагент Из МассивКонтрагентов Цикл 
		ЭтоЮрЛицо = Ложь;
		КСправочник = Справочники.Контрагенты.СоздатьЭлемент();
		КСправочник.ИНН = СокрЛП(мКонтрагент.Получить("inn"));	
				
		Если мКонтрагент.Получить("clientType") = "Физическое лицо" Тогда 
			ЮрФизЛицо = Перечисления.ЮридическоеФизическоеЛицо.ФизическоеЛицо;
			ЭтоЮрЛицо = Ложь;
		ИначеЕсли мКонтрагент.Получить("clientType") = "Обособленное подразделение"  Тогда 
			ЮрФизЛицо = Перечисления.ЮридическоеФизическоеЛицо.ЮридическоеЛицо;
			ЭтоЮрЛицо = Истина;
			КСправочник.ОбособленноеПодразделение = Истина;
		ИначеЕсли мКонтрагент.Получить("clientType") = "Государственный орган" Тогда  
			ЮрФизЛицо = Перечисления.ЮридическоеФизическоеЛицо.ЮридическоеЛицо;
			ЭтоЮрЛицо = Истина;
			КСправочник.ГосударственныйОрган = Истина;
		Иначе 
			ЮрФизЛицо = Перечисления.ЮридическоеФизическоеЛицо.ЮридическоеЛицо;
			ЭтоЮрЛицо = Истина;
	
		КонецЕсли;
		
		РезультатПроверки = ИдентификационныеНомераНалогоплательщиков.ПроверитьСоответствиеТребованиямИНН(КСправочник.ИНН, ЭтоЮрЛицо);
		
		Если РезультатПроверки.СоответствуетТребованиям Тогда	
			Если РезультатПроверки.ЭтоЮрЛицо Тогда
				РеквизитыКонтрагента = РаботаСКонтрагентами.РеквизитыЮридическогоЛицаПоИНН(КСправочник.ИНН);
			Иначе
				РеквизитыКонтрагента = РаботаСКонтрагентами.РеквизитыПредпринимателяПоИНН(КСправочник.ИНН);
			КонецЕсли;
		Иначе 
			Ошибка = Истина;
			ТекстОшибки ="ИНН Клиента: " + мКонтрагент.Получить("inn") + ". " +  РезультатПроверки.ОписаниеОшибки;
			СтруктураОтвета.Вставить("Ошибка", Ошибка);
			СтруктураОтвета.Вставить("ТекстОшибки", ТекстОшибки);
			ОтменитьТранзакцию();
			Возврат СтруктураОтвета;
		КонецЕсли;	
		Если ЗначениеЗаполнено(РеквизитыКонтрагента.ОписаниеОшибки) Тогда 
			Ошибка = Истина;
			ТекстОшибки = "ИНН Клиента: " + мКонтрагент.Получить("inn") + ". " +РеквизитыКонтрагента.ОписаниеОшибки;
			СтруктураОтвета.Вставить("Ошибка", Ошибка);
			СтруктураОтвета.Вставить("ТекстОшибки", ТекстОшибки);
			ОтменитьТранзакцию();
			Возврат СтруктураОтвета;
		КонецЕсли;
		ЗаполнитьЗначенияСвойств(КСправочник,РеквизитыКонтрагента);
		Если ЭтоЮрЛицо Тогда 
			ЮрАдрес = КСправочник.КонтактнаяИнформация.Добавить();
			ЮрАдрес.Тип = Перечисления.ТипыКонтактнойИнформации.Адрес;
			ЮрАдрес.Вид = Справочники.ВидыКонтактнойИнформации.ЮрАдресКонтрагента; 
			ЮрАдрес.Представление = РеквизитыКонтрагента.ЮридическийАдрес.Представление;
			
			ПочтовыйАдрес = КСправочник.КонтактнаяИнформация.Добавить();
			ПочтовыйАдрес.Тип = Перечисления.ТипыКонтактнойИнформации.Адрес;
			ПочтовыйАдрес.Вид = Справочники.ВидыКонтактнойИнформации.ПочтовыйАдресКонтрагента; 
			ПочтовыйАдрес.Представление = РеквизитыКонтрагента.ЮридическийАдрес.Представление;
			
			ФактАдрес = КСправочник.КонтактнаяИнформация.Добавить();
			ФактАдрес.Тип = Перечисления.ТипыКонтактнойИнформации.Адрес;
			ФактАдрес.Вид = Справочники.ВидыКонтактнойИнформации.ФактАдресКонтрагента; 
			ФактАдрес.Представление = РеквизитыКонтрагента.ЮридическийАдрес.Представление;
		КонецЕсли;
		
		КСправочник.ЮридическоеФизическоеЛицо =  ЮрФизЛицо;
		КСправочник.СтранаРегистрации =  Справочники.СтраныМира.НайтиПоРеквизиту("КодАльфа2", мКонтрагент.Получить("country"));	
		КСправочник.Родитель =  Справочники.Контрагенты.НайтиПоНаименованию(мКонтрагент.Получить("clientGroup"));
		
		Если КСправочник.Родитель.Пустая() Тогда 
			ЗаписьЖурналаРегистрации("Запись справочника (catalog)",УровеньЖурналаРегистрации.Предупреждение,,"Не удалось найти группу контрагента: " + мКонтрагент.Получить("clientGroup") + " ИНН клиента: " +  мКонтрагент.Получить("inn"));
		КонецЕсли;
		
		Телефон = КСправочник.КонтактнаяИнформация.Добавить();
		Телефон.Тип = Перечисления.ТипыКонтактнойИнформации.Телефон;
		Телефон.Вид = Справочники.ВидыКонтактнойИнформации.ТелефонКонтрагента; 
		Телефон.Представление = мКонтрагент.Получить("phone");
		
		Емайл =  КСправочник.КонтактнаяИнформация.Добавить();
		Емайл.Тип = Перечисления.ТипыКонтактнойИнформации.АдресЭлектроннойПочты;
		Емайл.Вид =  Справочники.ВидыКонтактнойИнформации.EmailКонтрагенты; 
		Емайл.Представление =  мКонтрагент.Получить("email");
		
		СсылкаВДокФло = ПланыВидовХарактеристик.ДополнительныеРеквизитыИСведения.НайтиПоРеквизиту("Имя", "СсылкаВДокФло_28e4d26c11254fce8da9d9438d01a248");
		ДопРеквизитСсылка = КСправочник.ДополнительныеРеквизиты.Добавить();
		ДопРеквизитСсылка.Свойство = СсылкаВДокФло;
		ДопРеквизитСсылка.Значение = мКонтрагент.Получить("linkDF");
		
		ИдентификатВДокФло = ПланыВидовХарактеристик.ДополнительныеРеквизитыИСведения.НайтиПоРеквизиту("Имя","ИдентификаторВДокФло_e1c7fbba1a3b4bb0a18b6777ae52d946");
		ДопРеквизитИдентификатор = КСправочник.ДополнительныеРеквизиты.Добавить();
		ДопРеквизитИдентификатор.Свойство = ИдентификатВДокФло;
		ДопРеквизитИдентификатор.Значение = мКонтрагент.Получить("idDF");
		Попытка
			КСправочник.Записать();
		Исключение
			Ошибка = Истина;
			ТекстОшибки = "ИНН Клиента: " + мКонтрагент.Получить("inn") + ". " + "Не удалось записать справочник";
			СтруктураОтвета.Вставить("Ошибка", Ошибка);
			СтруктураОтвета.Вставить("ТекстОшибки", ТекстОшибки);
			ОтменитьТранзакцию();		
			Возврат СтруктураОтвета;				
		КонецПопытки;
	КонецЦикла;
	СтруктураОтвета.Вставить("Ошибка", Ошибка);
	СтруктураОтвета.Вставить("ТекстОшибки", ТекстОшибки);
	
	ЗафиксироватьТранзакцию();
	Возврат СтруктураОтвета;
	
	//}ES Ситало А И
КонецФункции

